**********************************************************************
*		JAZZ - Main x Subroutines
**********************************************************************

* =IRAMBUFF : #800F5, we need to align to #80100 as is declared
* by the routine InitDisOps (see dis.s); use IRAMBUFF+11

**********************************************************************
* Name:		SX?
* Interface:	( --> flag )
**********************************************************************
*NULLNAME SG_ITE
*::
*NULLNAME SX?
*CODE
*	CD0EX
*	D0=(5)	=IRAM@
*	A=DAT0	S
*	CD0EX
*	A=A+A	S
*	GOVLNG	=PushF/TLoop
*ENDCODE
*  2'RCOLARPITE
*;
**********************************************************************
* Error if code itself is in tempob area
**********************************************************************
NULLNAME CHECKME
CODE
	AD0EX
*	D0=(5)	=aUSEROB
*	C=DAT0	A
*	D0=C
	D0=(5)	=USEROB

	C=DAT0	A
	AD0EX
	A=PC
	?A<C	A		* PC < USEROB ?
	GOYES	ERRME		* Yes - thus code is in tempob
	LOOP
ERRME	LC(5)	XerrNonFixed
	A=C	A
	GOVLNG	=Errjmp
ENDCODE
**********************************************************************
* Name:		TOTEMPBOT?
* Interface:	( ob --> ob' )
* Description:
* If object is in tempob area move it to bottom to fix it's location.
* Use direct memory block swap!
**********************************************************************
NULLNAME TOTEMPBOT?
CODE
		GOSBVL	=SAVPTR
		A=DAT1	A		* A[A] = ->ob
		GOSUB	GetBOT
		?A<C	A
		GOYES	GPLP
		GOSUB	GetTOP
		?A<C	A
		GOYES	isintemp
GPLP		GOVLNG	=GETPTRLOOP

*GetBOT		D0=(5)	=aTEMPOB
*		GOTO	gettop10
*GetTOP		D0=(5)	=aTEMPTOP
*gettop10	C=DAT0	A
*		D0=C
*		C=DAT0	A
*		RTN
GetBOT		D0=(5)	=TEMPOB
		GOTO	gettop10
GetTOP		D0=(5)	=aTEMPTOP
		C=DAT0	A
		D0=C
gettop10	C=DAT0	A
		RTN

* Ob is in tempob, move it to bottom
* If ROOM is too small then just execute GC and ob will be fixed

isintemp	B=A	A		* B[A] = ->ob
		C=C-CON	A,5
		D1=C

* Move down in tempob until ob is above temp ptr

tempdnlp	A=DAT1	A
		C=C-A	A		* C[A] = ->temp list
		D1=C
		?B<C	A		* Ob not in this temp area?
		GOYES	tempdnlp
		D1=D1+	5		* Skip link field (not marker!)
		B=A	A		* B[A] = oblen+6

* Move to tempbot using direct on-location block swap

		GOSUB	GetBOT
		D0=C
		D0=D0+	5		* Skip zero link
		C=B	A
* Now:
*	D0=->block1	(bottom of tempob area)
*	D1=->block2	(tail of link)
*	C[A]=nibbles2	(hole size)

*		GOSUB	BLKSWAP+	* Swap & update PTRs
		GOSBVL	=BLKSWAP+	* use ROM 2.15 code
		GOTO	GPLP

**********************************************************************
* Swap contiguous memory blocks in place.
* Entry:	D0= ->block1	(lower)
*		D1= ->block2	(higher)
*		C[A]= size of block2
* Alters:	A[W] C[W] B[A] D[A]
* Stack:	1 (BLKswap)
* Algorithm:
*
* If block2 is smaller than (or equal to) block1 then
*	swap block2 and start of block1
*	recalculate nibbles1, return block2 pointer back and restart
*		x                  y
*	Start:	1234567890123456789ABCDEF
*	End:	ABCDEF7890123456789123456
*		      x            y
* Else
*	swap block1 and start of block2
*	recalculate nibbles2 and restart
*		x     y
*	Start:	ABCDEF1234567890123456789
*	End:	123456ABCDEF7890123456789
*		      x      y
* Final result:
*		x                  y
*	Start:	1234567890123456789ABCDEF
*	Final:	ABCDEF1234567890123456789
*		                         x
* 
* Performance can be poor if one of the blocks is small.
* Setting compiler flag fUSEIRAM enables special code when either
* block is smaller than #100 nibbles. IRAMBUFF is then used as a buffer
* for the smaller block to do a buffered block swap.
*
**********************************************************************

* PTRADJUST2:
* Entry:	A[A]= ->block1	B[A]= ->block1tail	C[A]= offs1
* 		R0[A]= ->block2	R1[A]= ->block2tail	D0= offs2
* Exit:
*	All same as entry except C[A] moved to D[A]
* Uses:
*	D1 C[15-14]
* Applied:
* Entry:	A[A]= ->block1	B[A]= ->block2		C[A]= nibbles2
*		R0[A]= ->block2	R1[A]= ->block2tail	D0= -nibbles1

* Han:	found in ROM 2.15 (slight difference in registers used but
*	Jazz only uses it in TOTEMPBOT? (called by xDIS)
		
*BLKSWAP+	?C=0	A
*		RTNYES
*		AD1EX
*		B=A	A		B[A] = ->block2
*		R0=A			R0[A] = ->block2
*		RSTK=C
*		C=C+A	A
*		R1=C			R1[A] = ->block2tail
*		AD0EX			A[A] = ->block1
*		C=R0
*		C=C-A	A
*		C=-C	A
*		D0=C			D0 = -nibbles1
*		C=RSTK			C[A] = nibbles2
*		GOSBVL	=PTRADJUST2
** Restore entry conditions for BLKSWAP
*		D0=A			D0 = ->block1
*		A=B	A
*		D1=A			D1 = ->block2
*		C=D	A		C[A] = nibbles2
*
*BLKSWAP		B=C	A		B[A] = nibbles2 during loop
*BLKswaplp	?B=0	A		* Done if nibbles2 = 0
*		RTNYES
*		AD0EX
*		D0=A
*		CD1EX
*		D1=C
*		C=C-A	A		C[A] = nibbles1
*		?C=0	A		* Done if nibbles1 = 0
*		RTNYES
*		?C>=B	A		* nibbles1 >= nibbles2 ?
*		GOYES	BLKup&back	* Swap block & D1 comes back
*		A=C	A
*		A=0	B
*		?A=0	A
*		GOYES	BLKiram1	* Use IRAM if nibbles1 < #100
*		B=B-C	A		* Block 2 becomes smaller
*		GOSUB	BLKswap		* swap blocks of size nibbles1
*		GONC	BLKswaplp
*BLKup&back
*		A=B	A
*		A=0	B
*		?A=0	A
*		GOYES	BLKiram2	* Use IRAM if nibbles2 < #100
*		C=B	A		* nibbles2
*		GOSUB	BLKswap
*		CD1EX			* D1 back to where it was
*		C=C-B	A
*		CD1EX
*		GONC	BLKswaplp
*
** nibbles1 < #100. block1 to IRAM, block2 down, block1 to end
*BLKiram1	R0=C			R0[A] = nibbles1
*		CD0EX
*		R1=C			R1[A] = ->block1
*		D0=C
**		GOSUB	GETIRAM
**		D1=C
*		D1=(5)	=IRAMBUFF+11
*		C=R0
*		GOSBVL	=MOVEDOWN	Buffered block1, D0 = ->block2
*		A=R1
*		D1=A			D1 = ->block1
*		C=B	A		C[A] = nibbles2
*		GOSBVL	=MOVEDOWN	D1 = ->block2tail'
**		GOSUB	GETIRAM
**		D0=C
*		D0=(5)	=IRAMBUFF+11
*		C=R0			C[A] = nibbles1
*		GOVLNG	=MOVEDOWN
*		
** nibbles2 < #100. block2 to IRAM, block1 up, block2 to bottom
*BLKiram2	R0=C			R0[A] = nibbles1
*		CD1EX
*		R1=C			R1[A] = ->block2
*		D0=C			D0 = ->block2
**		GOSUB	GETIRAM
**		D1=C
*		D1=(5)	=IRAMBUFF+11
*		C=B	A		C[A] = nibbles2
*		GOSBVL	=MOVEDOWN	D0 = ->block2tail
*		C=R1
*		CD0EX			D0 = ->block2
*		D1=C			D1 = ->block2tail = ->block1tail'
*		C=R0
*		GOSBVL	=MOVEUP		D0 = ->block1
**		GOSUB	GETIRAM
*		LC(5)	=IRAMBUFF+11
*		CD0EX			D0 = ->buffer
*		D1=C			D1 = ->block1
*		C=B	A		C[A] = nibbles2
*		GOVLNG	=MOVEDOWN


* Han:	no longer needed for Bigapple
* GETIRAM	LC(5)	=IRAM@
*		CD0EX
*		C=DAT0	S
*		CD0EX
*		LC(5)	=IRAMBUFF
*		C=C+C	S
*		RTNNC
*		LC(5)	=G_IRAMBUFF
*		RTN

**********************************************************************
* Swap equal size blocks
* Entry:	D0= ->blk1	D1= ->blk2	C[A]= nibbles
* Exit:		D0= ->blk1 tail	D1= ->blk2 tail	CC
* Alters:	A[W] C[W] D[A] P CRY
**********************************************************************
*BLKswap		C=C-1	A
*		GOC	BLKupdone	* Nothing to swap
*		P=C	0		* P=nibs
*		CSR	A		* C[A]=words
*		D=C	A
*		D=D-1	A
*		GOC	BLKupwrd	* Swap the last <= 16 nibbles
*
*BLKuplp		A=DAT0	W		* Modified MOVEDOWN code
*		C=DAT1	W
*		DAT0=C	W
*		DAT1=A	W
*		D0=D0+	16
*		D1=D1+	16
*		D=D-1	B
*		GONC	BLKuplp
*		D=D-1	XS
*		GONC	BLKuplp
*		D=D+1	X
*		D=D-1	A
*		GONC	BLKuplp
*
*BLKupwrd	A=DAT0	WP
*		C=DAT1	WP
*		DAT0=C	WP
*		DAT1=A	WP
*		CD0EX
*		C+P+1
*		D0=C
*		CD1EX
*		C+P+1
*		D1=C
*BLKupdone	P=	0
*		RTNCC
ENDCODE

**********************************************************************
* Include the following to compile covered library
**********************************************************************
	INCLUDE misc/atempbot.s

ASSEMBLE
	INCLUDE	misc/memory.a
RPL
